Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2005122 - Review Request: python-lazy-ops - Lazy transposing and slicing of h5py and Zarr Datasets
Summary: Review Request: python-lazy-ops - Lazy transposing and slicing of h5py and Za...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Ben Beasley
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora 1931183
TreeView+ depends on / blocked
 
Reported: 2021-09-16 20:25 UTC by Ankur Sinha (FranciscoD)
Modified: 2021-10-29 23:09 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-10-28 19:30:47 UTC
Type: ---
Embargoed:
code: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2021-09-16 20:25:08 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-lazy-ops/python-lazy-ops.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-lazy-ops/python-lazy-ops-0.2.0-1.fc35.src.rpm

Description:
Lazy transposing and slicing of h5py Datasets and zarr arrays

Fedora Account System Username: ankursinha

Comment 1 Ben Beasley 2021-10-11 04:29:08 UTC
I was going to find the commit corresponding to the PyPI tarball, even though upstream did not tag it, and suggest using that for the tests—but there isn’t one!

The actual package sources (i.e., lazy_ops/ directory) match https://github.com/catalystneuro/lazy_ops/commit/407504d1c4b1447e9527e7bddd771b6cc6f4810a, but setup.py is not updated for 0.2.0 in that commit.

In the next commit, the version is 0.2.1, which is newer than any PyPI release, and there are additional changes in lazy_ops/.

-----

I guess something still has to be done, because there is no license file in the PyPI tarball, and the BSD license requires the license/copyright text to be reproduced (https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_license_text).

The more aggressive option would be to combine the GitHub tarball for commit 407504d1c4b1447e9527e7bddd771b6cc6f4810a with the PyPI 0.2.0 release tarball, using only the setup.py from the latter. That would give you the license file *and* let you run the tests.

Or, you could keep the PyPI tarball as you have it, and add https://github.com/catalystneuro/lazy_ops/raw/407504d1c4b1447e9527e7bddd771b6cc6f4810a/LICENSE as an additional source, still forgoing the tests.

What do you think?

Comment 2 Ankur Sinha (FranciscoD) 2021-10-15 18:08:46 UTC
I'd rather not combine bits---best to either use PyPi or the GitHub release tar.

For the time being, I think it's best to use the PyPi release and include the license as a different source. I've also filed this upstream now:

https://github.com/catalystneuro/lazy_ops/issues/26

I've requested that they keep pypi and GitHub in sync, and hopefully with that we'll be able to use the GitHub sources in the future and run all tests.

Updated spec/srpm:

Spec URL: https://ankursinha.fedorapeople.org/python-lazy-ops/python-lazy-ops.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-lazy-ops/python-lazy-ops-0.2.0-1.fc35.src.rpm

Comment 3 Ben Beasley 2021-10-15 19:34:07 UTC
Thanks. The license file handling looks good to me.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Dist tag is present.
  (fedora-review does not understand rpmautospec; there is no problem here)

- Manual BuildRequires are not needed. Change

    %pyproject_buildrequires

  to

    %pyproject_buildrequires -r

  and remove

    BuildRequires:  %{py3_dist numpy}
    BuildRequires:  %{py3_dist h5py}
    BuildRequires:  %{py3_dist zarr}

  Note that install_requires in setup.py only specifies h5py and zarr, even
  though this package uses numpy directly. Please consider asking upstream to
  add an explicit direct dependency on numpy. However, both h5py and zarr
  depend on numpy, so the implicit dependency will always be satisfied.

- Since python3-devel now requires pyproject-rpm-macros in all releases,

    BuildRequires:  pyproject-rpm-macros

  is no longer needed.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "Unknown or generated". 11 files have unknown
     license. Detailed output of licensecheck in
     /home/reviewer/2005122-python-lazy-ops/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.

      $ rpm -qL -p results/python3-lazy-ops-0.2.0-1.fc36.noarch.rpm 
      /usr/lib/python3.10/site-packages/lazy_ops-0.2.0.dist-info/LICENSE

[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-lazy-ops-0.2.0-1.fc36.noarch.rpm
          python-lazy-ops-0.2.0-1.fc36.src.rpm
python3-lazy-ops.noarch: W: spelling-error %description -l en_US zarr -> arr, Carr, Parr
python-lazy-ops.src: W: spelling-error %description -l en_US zarr -> arr, Carr, Parr
python-lazy-ops.src:55: W: macro-in-%changelog %autochangelog
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/catalystneuro/lazy_ops/raw/407504d1c4b1447e9527e7bddd771b6cc6f4810a/LICENSE :
  CHECKSUM(SHA256) this package     : 42e655522ab4ff6dbd7c4bb5d8c597a22c2e7d0548e53a63db49fe863c508558
  CHECKSUM(SHA256) upstream package : 42e655522ab4ff6dbd7c4bb5d8c597a22c2e7d0548e53a63db49fe863c508558
https://files.pythonhosted.org/packages/source/l/lazy_ops/lazy_ops-0.2.0.tar.gz :
  CHECKSUM(SHA256) this package     : 5f3ea1ab296f63e4dd4b2bef065356f1d797b07c96a6f7f5bbc3232c32f83bcc
  CHECKSUM(SHA256) upstream package : 5f3ea1ab296f63e4dd4b2bef065356f1d797b07c96a6f7f5bbc3232c32f83bcc


Requires
--------
python3-lazy-ops (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(h5py)
    python3.10dist(zarr)



Provides
--------
python3-lazy-ops:
    python-lazy-ops
    python3-lazy-ops
    python3.10-lazy-ops
    python3.10dist(lazy-ops)
    python3dist(lazy-ops)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2005122
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, Python
Disabled plugins: Java, SugarActivity, Haskell, Ocaml, PHP, Perl, fonts, C/C++, R
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Ankur Sinha (FranciscoD) 2021-10-18 18:13:22 UTC
Thanks very much for the review, Ben!

- removed the BRs and used `pyproject_buildrequires -r`, but I've left numpy in there for the moment just so that it's explicitly listed. Also sent a PR upstream for future releases: https://github.com/catalystneuro/lazy_ops/pull/27
- removed uneeded pyproject-rpm-macros BR

Spec URL: https://ankursinha.fedorapeople.org/python-lazy-ops/python-lazy-ops.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-lazy-ops/python-lazy-ops-0.2.0-1.fc35.src.rpm


Cheers,

Comment 5 Ben Beasley 2021-10-18 22:47:36 UTC
Thanks! Review of the spec file diff confirms you’ve included all of my suggestions, and the package is approved.

--- srpm-unpacked/python-lazy-ops.spec  2021-10-15 14:01:49.000000000 -0400
+++ re-review/python-lazy-ops.spec      2021-10-18 18:45:07.145125920 -0400
@@ -23,10 +23,10 @@
 %package -n python3-lazy-ops
 Summary:        %{summary}
 BuildRequires:  python3-devel
-BuildRequires:  pyproject-rpm-macros
+# Not listed in requirements
+# PR for future releases:
+# https://github.com/catalystneuro/lazy_ops/pull/27
 BuildRequires:  %{py3_dist numpy}
-BuildRequires:  %{py3_dist h5py}
-BuildRequires:  %{py3_dist zarr}
 
 %description -n python3-lazy-ops %_description
 
@@ -36,7 +36,7 @@
 cp %{SOURCE1} .
 
 %generate_buildrequires
-%pyproject_buildrequires
+%pyproject_buildrequires -r
 
 %build
 %pyproject_wheel

Comment 6 Gwyn Ciesla 2021-10-19 14:01:06 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-lazy-ops

Comment 7 Fedora Update System 2021-10-19 15:13:36 UTC
FEDORA-2021-cbd67f78ca has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-cbd67f78ca

Comment 8 Fedora Update System 2021-10-19 15:13:37 UTC
FEDORA-2021-f4577d5287 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-f4577d5287

Comment 9 Fedora Update System 2021-10-20 13:48:17 UTC
FEDORA-2021-f4577d5287 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-f4577d5287 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-f4577d5287

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-10-20 20:03:12 UTC
FEDORA-2021-cbd67f78ca has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-cbd67f78ca \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-cbd67f78ca

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2021-10-28 19:30:47 UTC
FEDORA-2021-cbd67f78ca has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 12 Fedora Update System 2021-10-29 23:09:14 UTC
FEDORA-2021-f4577d5287 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.